#include <stdio.h>
#include <io.h>
#include <errno.h>
#include <alloc.h>
#include <fcntl.h>
#include <sys\stat.h>

#define USAGETEXT "\nUsage: CC -? -W -N <culture number> -I <explicit CIV save filename> -#\n"\
"Where:  -? (or simply ?) shows this list\n"\
"        -W prints text describing what the program does\n"\
"        -I <inputfile> is an optional, explicit name for the CIV save file\n"\
"           If you do not specify, CIVILX.SVE is assumed (see following)\n"\
"        -# Will add the digit # (0-9) on to the end of CIVIL and look for the\n"\
"           file CIVIL#.SVE in the current directory (eg, CC -0 = CIVIL0.SVE)\n"\
"Example: \"CC 0\" modifies civil0.sve so that you will have $30,000.\n"


#define WHATIS\
"  The Civiilization save file cheater, by Richard Lawrence. This is a quick\n"\
"and dirty way to put 30,000 in the bank for a saved Civilization game. I may\n"\
"add other options later, depending on requests - the save file format looks\n"\
"pretty easy to figure out. This program will back up the currently saved file\n"\
"to CIVILx.BAK, where X is the save number, then write a new file that has a\n"\
"a large amount of money in the bank. WARNING: The only check I am currently\n"\
"making to see if the file is a real Civilization file is the length (37856).\n"\
"Use this program at your own risk. Type CC ? to get a list of options.\n"\
"\nRich Lawrence CI$: 71101,2272 Internet: rich@halluc.com Fido: 1:109/345\n"\
"              GEnie: r.lawrence14 BBS: 703-425-5824 (The Hallucination)\n"

void parse_command_line(int ,char **);
void parse_file_error(void);
void open_files(void);
unsigned char chk_read( int , void *, int );
unsigned char chk_write(int ,void *,int );
void terminate_program(char *,unsigned int );
void parse_call_log(void);
int main(int ,char **);

